package com.logicbig.example;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.hateoas.*;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import java.util.List;

@RestController
@ExposesResourceFor(Employee.class)
@RequestMapping("/employees")
public class EmployeeController {

    @Autowired
    private EntityLinks entityLinks;

    @GetMapping(value = "/{employeeId}")
    public Resource<Employee> getEmployeeById(@PathVariable long employeeId) {
        Link selfLink = entityLinks.linkToSingleResource(Employee.class, employeeId);
        Employee employee = getEmployee(employeeId);
        Resource<Employee> resource = new Resource<>(employee);
        resource.add(selfLink);
        return resource;
    }

    @GetMapping
    public Resources<Employee> getEmployees() {
        Link selfLink = entityLinks.linkToCollectionResource(Employee.class);
        List<Employee> employeeList = getEmployeeList();
        Resources<Employee> resources = new Resources<>(employeeList);
        resources.add(selfLink);
        return resources;
    }

    private List<Employee> getEmployeeList() {
        //todo: replace with employee service
        return List.of(getEmployee(1),
                Employee.create(2, "Tom", "IT", 4000));
    }

    private Employee getEmployee(long employeeId) {
        //todo: replace with employee service
        return Employee.create(employeeId, "Lara", "Admin", 3000);
    }
}